/* SPDX-License-Identifier: GPL-2.0 */
#ifndef _ASM_GENERIC_BITOPS_ARCH_PARITY_H_
#define _ASM_GENERIC_BITOPS_ARCH_PARITY_H_

#include <asm/types.h>

static inline bool __arch_parity8(u8 w)
{
	w ^= w >> 4;
	return (0x6996 >> (w & 0xf)) & 1;
}

static inline bool __arch_parity16(u16 w)
{
	return parity8(w ^ (w >> 8));
}

static inline bool __arch_parity32(u32 w)
{
	return parity16(w ^ (w >> 16));
}

static inline bool __arch_parity64(u64 w)
{
	return parity32(w ^ (w >> 32));
}

#endif /* _ASM_GENERIC_BITOPS_PARITY_H_ */
